create_resep/urls.py
from django.urls import path
from . import views

#url for app

app_name = 'create_resep'

urlpatterns = [
    path('',views.createResep, name='createResep'),
    path('daftarResep/', views.daftarResep, name='daftarResep'),
    path('deleteResep/', views.deleteResep, name='delete')
]

login/urls.py
from django.urls import path
from . import views

#url for app

app_name = 'login'

urlpatterns = [
    path('',views.fiturlogin, name='fiturlogin'),
    path('register/', views.register, name='register'),
    path('regisPasien/', views.regisPasien, name='pasien'),
    path('regisDoctor/', views.regisDoctor, name='doctor'),
    path('regisAdministrator/', views.regisAdm, name='admin'),
    path('logout/',views.logout,name='logout'),
    path('home/',views.home,name='home')
]

tugas_kelompok38/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('login.urls')),
    path('regisdokterrs/', include('reg_dokter_rs.urls')),
    path('layananpoli/', include('layanan_poli.urls')),
    path('transaksi/', include('transaksi.urls')),
    path('registerAdm/', include('regis_adm_to_RS.urls')),
    path('createResep/', include('create_resep.urls')),
    path('createObat/', include('create_obat.urls')),
    path('sesi_konsul/', include('sesi_konsultasi.urls')),
    path('rs_cabang/', include('rs_cabang.urls')),
]

create_resep/models.py
from django.db import models

# Create your models here.

create_resep/forms.py
from django import forms
from django.forms import widgets
from django.db import connection
import random
class FormResep(forms.Form):
    id_konsultasi = forms.ChoiceField(
        label = 'ID Konsultasi',
        choices=[('401', '401'),
                ('402', '402'),
                ('403', '403'),
                ('404', '404'),
                ('405', '405'),
                ('406', '406'),
                ('407', '407'),
                ('408', '408'),
                ('409', '409'),
                ('410', '410'),

                ],
        widget = forms.Select(attrs = {'class' : 'form-control'})

    )
    id_transaksi = forms.ChoiceField(
        label = 'ID Transaksi',
        choices = [
                ('1001', '1001'),
                ('1002', '1002'),
                ('1003', '1003'),
                ('1004', '1004'),
                ('1005', '1005'),
                ('1006', '1006'),
                ('1007', '1007'),
                ('1008', '1008'),
                ('1009', '1009'),
                ('1010', '1010'),
        ],
        widget = forms.Select(attrs = {'class' : 'form-control'})
    )
    kode_obat = forms.MultipleChoiceField(
        label = 'Daftar Kode Obat',
        choices = [('DCLGN','DCLGN'),
                ('OBH','OBH'),
                ('PNDL','PNDL'),
                ('TLKANGN','TLKANGN'),],
        widget = forms.CheckboxSelectMultiple(attrs = {'class' : 'form-control'})
    )
    
    def save(self, commit=True):
        id_konsultasi = self.cleaned_data.get('id_konsultasi')
        id_transaksi = self.cleaned_data.get('id_transaksi')
        kode_obat = self.cleaned_data.get('kode_obat')
        dosis = ['1','2','3''4','5']
        aturan_pakai = ['sebelum makan','sesudah makan']


    
        with connection.cursor() as cursor: 
            cursor.execute(
                "SELECT MAX(no_resep) from RESEP;"
            )
            data = cursor.fetchone()
            no_resep = int(data[0]) + 1
            print(no_resep)

            cursor.execute(
                "INSERT INTO RESEP(no_resep, id_konsultasi, total_harga, id_transaksi) VALUES('%s', '%s', %d, '%s');" % (no_resep, id_konsultasi, 0, id_transaksi)
            )
            for kode in kode_obat:
                cursor.execute(
                    "INSERT INTO DAFTAR_OBAT(no_resep, kode_obat, dosis, aturan) VALUES('%s', '%s', '%s', '%s');" % (no_resep, kode, random.choice(dosis), random.choice(aturan_pakai))
                )
        
    class Meta:
        # model = Resep
        fields= ('id_konsultasi','id_transaksi','kode_obat')
      

create_resep/views.py
from django.shortcuts import render,redirect
from .forms import FormResep
from django.http import HttpResponseRedirect
from django.db import connection

# Create your views here.
def createResep(request):
    form = FormResep
    if request.method=="POST":
        form= form(request.POST)
        if form.is_valid():
            form.save()
            return redirect('create_resep:daftarResep')            
            
    return render(request,'createResep.html', {'form' : form})

def daftarResep(request):
    daftar_resep = ''
    with connection.cursor() as resep:
        resep.execute("SELECT R.no_resep, R.id_konsultasi, R.total_harga, R.id_transaksi,"
        "STRING_AGG(D.kode_obat,',') as daftar_obat "
        "FROM RESEP R, DAFTAR_OBAT D "
        "WHERE R.no_resep = D.no_resep "
        "GROUP BY R.no_resep "
        "ORDER BY R.no_resep;")

        daftar_resep = resep.fetchall()

        return render(request, 'daftarResep.html',{'daftar_resep' : daftar_resep})
    
def deleteResep(request):
    if request.method == 'POST':
        no_resep = request.POST.get('no_resep')
        with connection.cursor() as admin:
            admin.execute("DELETE FROM RESEP WHERE no_resep=%s",[no_resep])
    return redirect('create_resep:daftarResep')

create_resep/templates/createResep.html
<!DOCTYPE html>
{% extends "base.html" %}
{% load static %}
{% block content %}
<html lang="en"> 
<head>
 <meta charset="UTF-8">
 <meta name="viewport" content="width=device-width, initial-scale=1.0">
 <meta http-equiv="X-UA-Compatible" content="ie=edge">
 <title>Create Resep</title>
 <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
 <link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
 <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.14/dist/css/bootstrap-select.min.css">
 <script src="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.14/dist/js/bootstrap-select.min.js"></script>
 <script src="https://code.jquery.com/jquery-1.12.4.js"></script>
 <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>

</head>
<body>
  {% if request.session.role == 'admin' %}
    <h1>FORM PEMBUATAN RESEP
    </h1>
    <form method="POST" style="padding: 25px;">
      {% csrf_token %}
      {{form}}
    
    <button type="submit" class="btn float-right btn-success ">Submit</button>
    </form>
  {% endif %}
  </body>
</html>
{% endblock %}

create_resep/templates/daftarResep.html
<!DOCTYPE html>
{% extends "base.html" %}
{% load static %}
{% block content %}
<html lang="en"> 
<head>
 <meta charset="UTF-8">
 <meta name="viewport" content="width=device-width, initial-scale=1.0">
 <meta http-equiv="X-UA-Compatible" content="ie=edge">
 <title>Daftar Resep</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
    <script src="https://code.jquery.com/jquery-1.12.4.js"></script>
    <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>

</head>
<body>
    <h1>Daftar Resep Obat</h1>
    {% if request.session.role == 'admin' %}
    <table class="table table-active table-hover">
        <tr>
            <th>Nomor Resep</th>
            <th>Total Harga</th>
            <th>ID Konsultasi</th>
            <th>ID Transaksi</th>
            <th>Daftar Obat</th>
            <th>Action[admin]</th>
        </tr>

        {% for columnResep in daftar_resep %}
        <tr> 
            <td>{{ columnResep.0 }}</td>
            <td>{{ columnResep.2 }}</td>
            <td>{{ columnResep.1 }}</td>
            <td>{{ columnResep.3 }}</td>
            <td>{{ columnResep.4 }}</td>
              
            <td>
                <div class="d-flex flex-row">
                <button type="submit" class="btn btn-success">Update</button>
             
                <form action="{% url 'create_resep:delete' %}" method="POST" class="delete">
                    {% csrf_token %}
                    <input type="hidden" name="no_resep" value="{{ columnResep.0 }}">
                    <button type="submit" class="btn btn-danger">Delete</button>
                </form>
                </div>
                <br>
            </td>
        </tr>
        {% endfor %}
    </table>
    {% else %}
    <table class="table table-active table-hover">
        <tr>
            <th>Nomor Resep</th>
            <th>Total Harga</th>
            <th>ID Konsultasi</th>
            <th>ID Transaksi</th>
            <th>Daftar Obat</th>
        </tr>

        {% for columnResep in daftar_resep %}
        <tr> 
            <td>{{ columnResep.0 }}</td>
            <td>{{ columnResep.2 }}</td>
            <td>{{ columnResep.1 }}</td>
            <td>{{ columnResep.3 }}</td>
            <td>{{ columnResep.4 }}</td>
        </tr>
        {% endfor %}
  </body>
  {% endif %}
</html>
{% endblock %}